Index: /palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/average_3d_data.f90	(revision 771)
+++ /palm/trunk/SOURCE/average_3d_data.f90	(revision 772)
@@ -4,8 +4,11 @@
 ! Current revisions:
 ! -----------------
-! +lpt_av
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 771 2011-10-27 10:56:21Z heinze
+! +lpt_av
 !
 ! 667 2010-12-23 12:06:00Z suehring/gryschka
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 771)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 772)
@@ -4,5 +4,4 @@
 ! Current revisions:
 ! -----------------
-! +lpt
 !
 ! Former revisions:
Index: /palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_2d.f90	(revision 771)
+++ /palm/trunk/SOURCE/data_output_2d.f90	(revision 772)
@@ -4,9 +4,11 @@
 ! Current revisions:
 ! -----------------
-! +lpt
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 771 2011-10-27 10:56:21Z heinze
+! +lpt
 !
 ! 759 2011-09-15 13:58:31Z raasch
Index: /palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_3d.f90	(revision 771)
+++ /palm/trunk/SOURCE/data_output_3d.f90	(revision 772)
@@ -4,9 +4,11 @@
 ! Current revisions:
 ! -----------------
-! +lpt
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 771 2011-10-27 10:56:21Z heinze
+! +lpt
 !
 ! 759 2011-09-15 13:58:31Z raasch
Index: /palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_mask.f90	(revision 771)
+++ /palm/trunk/SOURCE/data_output_mask.f90	(revision 772)
@@ -4,9 +4,11 @@
 ! Current revisions:
 ! -----------------
-! +lpt
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 771 2011-10-27 10:56:21Z heinze
+! +lpt
 !
 ! 667 2010-12-23 12:06:00Z suehring/gryschka
Index: /palm/trunk/SOURCE/init_masks.f90
===================================================================
--- /palm/trunk/SOURCE/init_masks.f90	(revision 771)
+++ /palm/trunk/SOURCE/init_masks.f90	(revision 772)
@@ -4,9 +4,11 @@
 ! Current revisions:
 ! -----------------
-! +lpt
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 771 2011-10-27 10:56:21Z heinze
+! +lpt
 !
 ! 595 2010-11-12 09:52:10Z helmke
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 771)
+++ /palm/trunk/SOURCE/modules.f90	(revision 772)
@@ -5,9 +5,11 @@
 ! Current revisions:
 ! -----------------
-! +lpt_av
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 771 2011-10-27 10:56:21Z heinze
+! +lpt_av
 !
 ! 767 2011-10-14 06:39:12Z raasch
Index: /palm/trunk/SOURCE/netcdf.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf.f90	(revision 771)
+++ /palm/trunk/SOURCE/netcdf.f90	(revision 772)
@@ -7,9 +7,11 @@
 ! Current revisions:
 ! ------------------
-! +lpt
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 771 2011-10-27 10:56:21Z heinze
+! +lpt
 !
 ! 600 2010-11-24 16:10:51Z raasch
Index: /palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- /palm/trunk/SOURCE/read_3d_binary.f90	(revision 771)
+++ /palm/trunk/SOURCE/read_3d_binary.f90	(revision 772)
@@ -4,9 +4,11 @@
 ! Current revisions:
 ! -----------------
-! +lpt_av
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 771 2011-10-27 10:56:21Z heinze
+! +lpt_av
 !
 ! 667 2010-12-23 12:06:00Z suehring/gryschka
Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 771)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 772)
@@ -4,9 +4,11 @@
 ! Current revisions:
 ! -----------------
-! lpt_av
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 771 2011-10-27 10:56:21Z heinze
+! +lpt_av
 !
 ! 667 2010-12-23 12:06:00Z suehring/gryschka
Index: /palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- /palm/trunk/SOURCE/write_3d_binary.f90	(revision 771)
+++ /palm/trunk/SOURCE/write_3d_binary.f90	(revision 772)
@@ -4,9 +4,11 @@
 ! Current revisions:
 ! -----------------
-! +lpt
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 771 2011-10-27 10:56:21Z heinze
+! +lpt
 !
 ! 759 2011-09-15 13:58:31Z raasch