Index: /palm/trunk/SCRIPTS/NCL/profiles.ncl
===================================================================
--- /palm/trunk/SCRIPTS/NCL/profiles.ncl	(revision 782)
+++ /palm/trunk/SCRIPTS/NCL/profiles.ncl	(revision 783)
@@ -3196,5 +3196,5 @@
          lgMonoDashIndex          = False
          lgres@lgLabelFont        = "helvetica"    
-         lgres@lgLabelFontHeightF = font_size_legend            
+         lgres@lgLabelFontHeightF = font_size_legend*10.0       
          lgres@vpWidthF           = max(string_len)*0.015           
          lgres@vpHeightF          = 0.03*no_files          
@@ -3411,5 +3411,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend            
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0            
                   lgres@vpWidthF           = 0.07           
                   lgres@vpHeightF          = 0.12          
@@ -3462,5 +3462,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend          
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0          
                   lgres@vpWidthF           = 0.07           
                   lgres@vpHeightF          = 0.12          
@@ -3511,5 +3511,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend            
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0          
                   lgres@vpWidthF           = 0.07          
                   lgres@vpHeightF          = 0.12          
@@ -3559,5 +3559,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend           
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0           
                   lgres@vpWidthF           = 0.07           
                   lgres@vpHeightF          = 0.08          
@@ -3605,5 +3605,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend           
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0           
                   lgres@vpWidthF           = 0.07           
                   lgres@vpHeightF          = 0.08          
@@ -3657,5 +3657,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend            
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0            
                   lgres@vpWidthF           = 0.08           
                   lgres@vpHeightF          = 0.12          
@@ -3709,5 +3709,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend            
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0            
                   lgres@vpWidthF           = 0.08          
                   lgres@vpHeightF          = 0.12          
@@ -3761,5 +3761,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend            
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0            
                   lgres@vpWidthF           = 0.09           
                   lgres@vpHeightF          = 0.12          
@@ -3809,5 +3809,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend            
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0            
                   lgres@vpWidthF           = 0.1           
                   lgres@vpHeightF          = 0.12          
@@ -3861,5 +3861,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend            
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0            
                   lgres@vpWidthF           = 0.1           
                   lgres@vpHeightF          = 0.12          
@@ -3912,5 +3912,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend           
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0           
                   lgres@vpWidthF           = 0.08           
                   lgres@vpHeightF          = 0.12          
@@ -3964,5 +3964,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend            
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0            
                   lgres@vpWidthF           = 0.09           
                   lgres@vpHeightF          = 0.12         
@@ -4016,5 +4016,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend            
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0            
                   lgres@vpWidthF           = 0.08           
                   lgres@vpHeightF          = 0.12          
@@ -4068,5 +4068,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend            
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0            
                   lgres@vpWidthF           = 0.09           
                   lgres@vpHeightF          = 0.12          
@@ -4120,5 +4120,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend            
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0            
                   lgres@vpWidthF           = 0.07           
                   lgres@vpHeightF          = 0.12          
@@ -4176,5 +4176,5 @@
                   lgMonoDashIndex          = False
                   lgres@lgLabelFont        = "helvetica"    
-                  lgres@lgLabelFontHeightF = font_size_legend           
+                  lgres@lgLabelFontHeightF = font_size_legend*10.0           
                   lgres@vpWidthF           = 0.12           
                   lgres@vpHeightF          = 0.12          
@@ -4343,5 +4343,5 @@
       lgres@lgDashIndexes      = (/0,1,2/)
       lgres@lgLabelFont        = "helvetica"    
-      lgres@lgLabelFontHeightF = font_size_legend           
+      lgres@lgLabelFontHeightF = font_size_legend*10.0           
       lgres@vpWidthF           = 0.12           
       lgres@vpHeightF          = 0.1           