Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 790)
+++ /palm/trunk/SOURCE/Makefile	(revision 791)
@@ -4,9 +4,12 @@
 # Current revisions:
 # ------------------
-# +wang_kernel
+# 
 #
 # Former revisions:
 # -----------------
 # $Id$
+#
+# 790 2011-11-29 03:11:20Z raasch
+# +wang_kernel
 #
 # 667 2010-12-23 12:06:00Z suehring/gryschka
Index: /palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_2d.f90	(revision 790)
+++ /palm/trunk/SOURCE/data_output_2d.f90	(revision 791)
@@ -4,9 +4,12 @@
 ! Current revisions:
 ! -----------------
-! bugfix: calculation of 'pr' must depend on the particle weighting factor
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 790 2011-11-29 03:11:20Z raasch
+! bugfix: calculation of 'pr' must depend on the particle weighting factor
 !
 ! 771 2011-10-27 10:56:21Z heinze
Index: /palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_3d.f90	(revision 790)
+++ /palm/trunk/SOURCE/data_output_3d.f90	(revision 791)
@@ -4,10 +4,13 @@
 ! Current revisions:
 ! -----------------
-! bugfix: calculation of 'pr' must depend on the particle weighting factor,
-! nzt+1 replaced by nz_do3d for 'pr'
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 790 2011-11-29 03:11:20Z raasch
+! bugfix: calculation of 'pr' must depend on the particle weighting factor,
+! nzt+1 replaced by nz_do3d for 'pr'
 !
 ! 771 2011-10-27 10:56:21Z heinze
Index: /palm/trunk/SOURCE/diffusion_e.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_e.f90	(revision 790)
+++ /palm/trunk/SOURCE/diffusion_e.f90	(revision 791)
@@ -4,9 +4,12 @@
 ! Current revisions:
 ! -----------------
-! diss is also calculated in case that the Wang kernel is used
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 790 2011-11-29 03:11:20Z raasch
+! diss is also calculated in case that the Wang kernel is used
 !
 ! 667 2010-12-23 12:06:00Z suehring/gryschka
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 790)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 791)
@@ -7,9 +7,12 @@
 ! Current revisions:
 ! ------------------
-! diss is also allocated in case that the Wang kernel is used
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 790 2011-11-29 03:11:20Z raasch
+! diss is also allocated in case that the Wang kernel is used
 !
 ! 787 2011-11-28 12:49:05Z heinze $
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 790)
+++ /palm/trunk/SOURCE/modules.f90	(revision 791)
@@ -5,9 +5,12 @@
 ! Current revisions:
 ! -----------------
-! +turbulence_effects_on_collision, wang_collision_kernel
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 790 2011-11-29 03:11:20Z raasch
+! +turbulence_effects_on_collision, wang_collision_kernel
 !
 ! 785 2011-11-28 09:47:19Z raasch
Index: /palm/trunk/SOURCE/package_parin.f90
===================================================================
--- /palm/trunk/SOURCE/package_parin.f90	(revision 790)
+++ /palm/trunk/SOURCE/package_parin.f90	(revision 791)
@@ -4,9 +4,12 @@
 ! Current revisions:
 ! -----------------
-! +turbulence_effects_on_collision, wang_collision_kernel in particles_par
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 790 2011-11-29 03:11:20Z raasch
+! +turbulence_effects_on_collision, wang_collision_kernel in particles_par
 !
 ! 336 2009-06-10 11:19:35Z raasch
Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 790)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 791)
@@ -4,9 +4,12 @@
 ! Current revisions:
 ! -----------------
-! bugfix: calculation of 'pr' must depend on the particle weighting factor
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 790 2011-11-29 03:11:20Z raasch
+! bugfix: calculation of 'pr' must depend on the particle weighting factor
 !
 ! 771 2011-10-27 10:56:21Z heinze
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 790)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 791)
@@ -4,9 +4,12 @@
 ! Current revisions:
 ! -----------------
-! exchange of ghostpoints for array diss
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 790 2011-11-29 03:11:20Z raasch
+! exchange of ghostpoints for array diss
 !
 ! 707 2011-03-29 11:39:40Z raasch
Index: /palm/trunk/SOURCE/wang_kernel.f90
===================================================================
--- /palm/trunk/SOURCE/wang_kernel.f90	(revision 790)
+++ /palm/trunk/SOURCE/wang_kernel.f90	(revision 791)
@@ -10,4 +10,6 @@
 ! $Id$
 !
+! 790 2011-11-29 03:11:20Z raasch
+! initial revision
 !
 ! Description:
Index: /palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- /palm/trunk/SOURCE/write_3d_binary.f90	(revision 790)
+++ /palm/trunk/SOURCE/write_3d_binary.f90	(revision 791)
@@ -4,9 +4,12 @@
 ! Current revisions:
 ! -----------------
-! bugfix: output of 'ql' also if cloud droplets are used
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 790 2011-11-29 03:11:20Z raasch
+! bugfix: output of 'ql' also if cloud droplets are used
 !
 ! 776 2011-10-31 08:02:51Z heinze